% (c) 2009-2018 Lehrstuhl fuer Softwaretechnik und Programmiersprachen,
% Heinrich Heine Universitaet Duesseldorf
% This software is licenced under EPL 1.0 (http://www.eclipse.org/org/documents/epl-v10.html)

:- module(counter, [
                    counter_init/0,
                    new_counter/1,
                    get_counter/2,
                    set_counter/2,
                    inc_counter/1, inc_counter/2,
                    reset_counter/1
                   ]).

foreign_resource('counter', [new_counter,get_counter,inc_counter,set_counter,reset_counter]).
foreign(new_counter, c, new_counter(+atom)).
foreign(get_counter, c, get_counter(+atom, [-integer])).
foreign(inc_counter, c, inc_counter(+atom, [-integer])).
foreign(set_counter, c, set_counter(+atom, +integer)).
foreign(reset_counter, c, reset_counter(+atom)).

% with this line below we need to adapt the Makefile to include the counter resource in the binary:
% (maybe this is a good idea)
% :- load_foreign_resource(counter).

:- dynamic loaded/0.

counter_init :-
  (loaded -> true
   ; (assert(loaded),
      %assert_dir,
      assert(user:library_directory('.')),
      %print('loading counter foreign resource'),nl,
      load_foreign_resource(library(counter)))
   ).

inc_counter(Counter) :-
    inc_counter(Counter, _NewVal).
