# LTSmin Integration scaffolding

* ltsmin.pl: Prolog integration for the LTSmin server.
* ltsmin.c: Server that waits for the LTSmin counterpart. It supports all basic protocol messages (init, get next states, get state label and terminate).
* client.c: Client demonstrator. It sends init, receives the initial state from ProB, asks for the successor states and then for a state label evaluated on the last successor state from the previous request.
* helpers.c/helpers.h Code that is shared between server and client to wrap/unwrap chunks and states in network messages.
* ltsmin-protocol.txt Description of the messages sent between server and client.


## What is missing?

3. The client should be integrated with LTSmin.
4. LTSmin should call: ```send_init```, ```send_next_state```,``` send_get_state_label``` and ```terminate```. ```send_next_state``` and ```send_get_state_label``` expect a State type (see helpers.h) as input.
5. The chunk <-> int mapping has to be implemented in client.c
1. We need to complete the initialization message (i.e., we probably need the LTL formula, additional state labels and the matrices)

## Compilation:
* Server: normal make in ProB (a binary that is built after every push to this repo is available from https://www3.hhu.de/stups/downloads/prob/ltsmin/)
* Client: ```make client```
*
## Running the demo

1. Start ProB tcltk (use the binary from https://www3.hhu.de/stups/downloads/prob/ltsmin/)
2. Switch to normal mode (Preferences|User mode)
3. Load a B model
2. Click Verify | External Tools | ModelCheck with LTSmin...

ProB will now wait for incomming messages, process them and reply.

Run the client, it will send some data and print out what it receives from ProB.
Treat everything you get from ProB as a binary format, in particulary do not assume that everthing starts with DA as it currently does.
Use the helper functions defined in helper.c to extract and store information.
