#define _GNU_SOURCE

#include <stdlib.h>
#include <stdio.h>

#include <zmq.h>
#include <czmq.h>

#include "../common/msg_headers.h"

/* I log messages that I like. */


int main(int argc, char *argv[]) {
    char *master_ip = argv[1];
    int port_start = atoi(argv[2]);


    char *endpoint = NULL;
    int rc = asprintf(&endpoint, "tcp://%s:%d", master_ip, port_start + 1);
    assert(rc != -1);

    zsock_t *sub = zsock_new_sub(endpoint, "");
    free(endpoint);


    FILE *msg_log = fopen("msgs_published.log", "w");
    zsys_set_logstream(msg_log);

    int its_over = 0;

    while (!its_over) {
        int header;
        zmsg_t *msg;
        rc = zsock_recv(sub, "im", &header, &msg);
        assert(rc == 0);

        switch (header) {
            case (CTRL_TERM):
                zmsg_destroy(&msg);
                its_over = 1;
                break;
            case (CTRL_TRANSFER_TO):
                zmsg_print(msg); // fall through
            default:
                zmsg_destroy(&msg);
        }
    }

    fclose(msg_log);

    zsock_destroy(&sub);
    return 0;
}
