#include <zmq.h>
#include <czmq.h>

#include "../common/hash.h"
int main(int argc, char *argv[]) {
    zsock_t *zocket = zsock_new_pull("tcp://*:5001");

    int header;
    int nr_results;
    zmsg_t *msg;
    int rc = zsock_recv(zocket, "iim", &header, &nr_results, &msg);
    assert(rc == 0);

    printf("%x\n", header);
    
    int i;
    puts("Results:");
    for (i = 0; i < nr_results; i++) {
        char *res = zmsg_popstr(msg);
        puts(res);
    }

    puts("Hashes:");
    char *framedata = NULL;
    while((framedata = zmsg_popstr(msg)) != NULL) {
        char buf[HASH_LEN * 2+1];
        print_readable_digest((unsigned char*) framedata, buf);
        puts(buf);
    }
    zsock_destroy(&zocket);
    return 0;
}
