#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif
#include <stdio.h>
#include <assert.h>

#include "../common/queue.h"
#include "../common/hash.h"

#include "../master/mstats.h"
#include "../common/msg_headers.h"

#include "test_helpers.h"

wQueue *get_queue(size_t len) {
    wQueue *q = init_queue(0);
    size_t i;
    for (i = 0; i < len; i++) {
        char *term;
        int rc = asprintf(&term, "%lu", i);
        assert(rc != -1);
        
        char digest[HASH_LEN];
        hash(term, rc + 1, digest);
        
        enqueue(q, term, rc + 1, digest);
    }
    return q;
}

pDigest get_pdigest(int header, int amount) {
    pDigest res = {0};
    res.header = header;
    switch(header) {
        case PSTATS_HAS_PMS:
            break;
        case PSTATS_HAS_FULL:
            res.full = amount;
            break;
        case PSTATS_HAS_EMPTY:
            res.empty = amount;
            break;
    }

    return res;
}
