#include <assert.h>
#include <stdlib.h>
#include <stdio.h>

#include <zmq.h>
#include <czmq.h>

#include "../master/mpull.h"

static void test_put_wqueues_msg1(void) {
    struct worker_queuesizes wqs = {0, NULL, 0};
    zmsg_t *msg = zmsg_new();
    zmsg_addstr(msg, "2");
    zmsg_addstr(msg, "1234");

    put_wqueues_msg(&wqs, msg);

    assert(wqs.len == 2);
    assert(wqs.update_count == 1);
    assert(wqs.queue_msgs[1] == NULL);
    assert(wqs.queue_msgs[2] != NULL);

    teardown_worker_queuesizes(&wqs);
    printf(".");
}

static void test_put_wqueues_msg2(void) {
    struct worker_queuesizes wqs = {0, NULL, 0};
    zmsg_t *msg = zmsg_new();
    zmsg_addstr(msg, "2");
    zmsg_addstr(msg, "1234");

    put_wqueues_msg(&wqs, msg);

    zmsg_t *msg2 = zmsg_new();
    zmsg_addstr(msg2, "2");
    zmsg_addstr(msg2, "4321");

    // this mostly is a test for leaks
    put_wqueues_msg(&wqs, msg2);

    assert(wqs.len == 2);
    assert(wqs.update_count == 2);
    assert(wqs.queue_msgs[1] == NULL);
    assert(wqs.queue_msgs[2] != NULL);

    teardown_worker_queuesizes(&wqs);
    printf(".");
}

int main(int argc, char *argv[]) {
    test_put_wqueues_msg1();
    test_put_wqueues_msg2();

    puts("");
    return 0;
}
