#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif
#include <assert.h>
#include <stdio.h>
#include <stdlib.h>

#include <zmq.h>
#include <czmq.h>

#include "../common/queue.h"
#include "wpush.h"

zsock_t *init_wpush(const int proxy_number) {
    char *endpoint_push;
    int rc = asprintf(&endpoint_push,"ipc:///tmp/zmq-proxy-%d-pushpull", proxy_number);
    assert(rc != -1);

    zsock_t *res = zsock_new_push(endpoint_push);
    free(endpoint_push);
    return res;
}

/* sends a TRANSFER-DONE message with provided header, worker ID and queuesize
 * via the push-zocket */
void signal_transfer_done(zsock_t * const push,
                          const int ack_header,
                          const int id,
                          wQueue const * const q,
                          const uint64_t timestamp) {
    size_t qs = q_size(q);
    int rc = zsock_send(push, "i8ib", ack_header, timestamp, id, (char*) &qs, 8); // FIXME: really don't to that
    assert(rc == 0);
}

